.\" Hey Emacs! This file is -*- nroff -*- source.
.\"
.\" Copyright (c) 1993 Michael Haardt (michael@moria.de),
.\"   Fri Apr  2 11:32:09 MET DST 1993
.\"
.\" This is free documentation; you can redistribute it and/or
.\" modify it under the terms of the GNU General Public License as
.\" published by the Free Software Foundation; either version 2 of
.\" the License, or (at your option) any later version.
.\"
.\" The GNU General Public License's references to "object code"
.\" and "executables" are to be interpreted as the output of any
.\" document formatting or typesetting system, including
.\" intermediate and printed output.
.\"
.\" This manual is distributed in the hope that it will be useful,
.\" but WITHOUT ANY WARRANTY; without even the implied warranty of
.\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\" GNU General Public License for more details.
.\"
.\" You should have received a copy of the GNU General Public
.\" License along with this manual; if not, write to the Free
.\" Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111,
.\" USA.

.\"
.\" Tue Jul  6 12:42:46 MDT 1993 <dminer@nyx.cs.du.edu>
.\" Added "Calling Directly" and supporting paragraphs
.\"
.\" Modified Sat Jul 24 15:19:12 1993 by Rik Faith <faith@cs.unc.edu>
.\"
.\" Modified 21 Aug 1994 by Michael Chastain <mec@shell.portal.com>:
.\"   Added explanation of arg stacking when 6 or more args.
.\"
.\" Modified 10 June 1995 by Andries Brouwer <aeb@cwi.nl>
.\"
.\"     14.12.2003
.\"     <alexm@hsys.msk.ru> 1999-2001
.\"        <corochoone@perm.ru>
.\" http://www.linuxshare.ru/projects/trans/mans.html
.\"
.TH INTRO 2 1996-05-22 "Linux 1.2.13" "  Linux"
.SH 
intro, _syscall \-  : 
.SH 
      Linux.    164
    syscalls(2).
.SS " "
       
,   ,     C
(libc)   -  .

.SS " "
.B #include <linux/unistd.h>

A _syscall macro

desired system call

.SS 
     .    ,
    ,   ,  ,
 .    ,  
.    :
.sp
.RS
.RI _syscall X ( type , name , type1 , arg1 , type2 , arg2 ,...)
.RS
.HP
 \fIX\fP   0  5    ,
  
.HP
\fItype\fP  ,   
.HP
\fIname\fP   
.HP
\fItypeN\fP  N- 
.HP
\fIargN\fP  N- 
.RE
.RE
.sp
   ,   \fIname\fP, 
 .   ,     _syscall()
     ,     ,
  \fIname\fP.
.SH 
.nf
.sp
#include <stdio.h>
#include <linux/unistd.h>	/* for _syscallX macros/related stuff */
#include <linux/kernel.h>	/* for struct sysinfo */

_syscall1(int, sysinfo, struct sysinfo *, info);

/* Note: if you copy directly from the nroff source, remember to
REMOVE the extra backslashes in the printf statement. */

int main(void)
{
	struct sysinfo s_info;
	int error;

	error = sysinfo(&s_info);
	printf("code error = %d\\n", error);
        printf("Uptime = %lds\\nLoad: 1 min %lu / 5 min %lu / 15 min %lu\\n"
                "RAM: total %lu / free %lu / shared %lu\\n"
                "Memory in buffers = %lu\\nSwap: total %lu / free %lu\\n"
                "Number of processes = %d\\n",
		s_info.uptime, s_info.loads[0],
		s_info.loads[1], s_info.loads[2],
		s_info.totalram, s_info.freeram,
		s_info.sharedram, s_info.bufferram,
		s_info.totalswap, s_info.freeswap,
		s_info.procs);
	return(0);
}
.fi
.SH " "
.nf
code error = 0
uptime = 502034s
Load: 1 min 13376 / 5 min 5504 / 15 min 1152
RAM: total 15343616 / free 827392 / shared 8237056
Memory in buffers = 5066752
Swap: total 27881472 / free 24698880
Number of processes = 40
.fi
.SH 
 _syscall()   .    
  ,     C++.
.sp
       
  .      ,
     .    
--       , ,
\-\fBEPERM\fP.   _syscall()   

.IR r ,

.I r
,      \-1  

.I errno
  \-\fIr\fP.
   
.BR errno (3).
.sp
  ,  
.BR mmap ,
   .     
        .
.sp
       "
"     (  , ,
).
.sp
    ,    ݣ
  glibc,   
.BR syscall (2).
.SH " "
   Unix   , 
  ,     ,
  :
.TP
SVr4
Unix-System V Release 4,   "Programmer's Reference
Manual: Operating System API (Intel processors)" (Prentice-Hall
1992, ISBN 0-13-951294-2)
.TP
SVID
System V Interface Definition (   V),
  "The System V Interface Definition, Fourth Edition".
.TP
POSIX.1 
IEEE 1003.1-1990  1,    ISO/IEC 9945-1:1990s,
   "IEEE Portable Operating System Interface for
Computing Environments" (   
   IEEE),    Donald Lewine
"POSIX Programmer's Guide" (O'Reilly & Associates, Inc., 1991, ISBN
0-937175-73-0.
.TP
POSIX.1b
IEEE Std 1003.1b-1993 ( POSIX.1b),  
       ,
   Bill O. Gallmeister "Programming for the real
world \- POSIX.4" (O'Reilly & Associates, Inc. ISBN 1-56592-074-0).
.TP
4.3BSD/4.4BSD
 4.3  4.4.  Berkeley Unix.  4.4BSD  
  4.3.
.TP
SUS, SUSv2
Single Unix Specification.  ( X/Open  The Open Group.
  http://www.UNIX-systems.org/version2/.)
.TP
V7
 7,   Unix  Bell Labs.
.SH 
.I /usr/include/linux/unistd.h
.SH " "
.BR errno (3)
.BR syscall (2),
.SH 
Copyright (C) Alexey Mahotkin <alexm@hsys.msk.ru> 1999,
  <corochoone@perm.ru> 2003
